
//Programmer für TPS (HOLTEK) mit Arduino Uno als Interface, Version 1

byte i, n, p, ZZ, Nibble, Nibble1, Nibble2, Max;
int BAUDRATE, addr, c;
#define debug;

void setup() {
BAUDRATE = 9600;
 pinMode(11,OUTPUT);
 pinMode(12,OUTPUT);
 pinMode(13,OUTPUT);
digitalWrite(13,HIGH);
digitalWrite(12,HIGH);
digitalWrite(11,HIGH);
}

void loop() {

  byte value, x;
  bool endOfPrg = false;
  bool endOfFile = false;
  byte data[32], DD[128];
  word readAddress;
  int crc, readcrc;
  byte count;
  byte type;
 char myChar;
 
  addr = 0;
  
  Serial.end();
  Serial.begin(BAUDRATE);
  Serial.flush();
  Serial.println();                     //wenn das fehlt, kommt "ARDUINO antwortet nicht"
  Serial.println("TPS Programmer");

while(!Serial.available()){};             //wartet, bis etwas kommt
  
  while (!endOfPrg) { 
   
      // look for the next valid integer in the incoming serial stream:
     
  while (Serial.available() > 0) {     //look for next valid integer

          myChar = Serial.read();
          if (myChar == 'w') {
          endOfFile = false;
          Serial.println("ready");
          
        addr = 0;
        do {
          for (byte i = 0; i < 8; i++) {
            data[i] = 0xFF;
          }
        do { 
            c = getNextChar();
          } while (!(c == ':'));          

#ifdef debug
          Serial.print("a"); 
#endif
          // read counter
          c = getNextChar();
          count = hexToByte(c) << 4;
          c = getNextChar();
          count += hexToByte(c);            //count = Anzahl der Programmzeilen/Seite
#ifdef debug
          printHex8(count);   
#endif

          crc = count;
#ifdef debug
          Serial.print("b"); 
#endif
          // address
          c = getNextChar();
          readAddress = hexToByte(c) << 12;
          c = getNextChar();
          readAddress += hexToByte(c) << 8;
          c = getNextChar();
          readAddress += hexToByte(c) << 4;
          c = getNextChar();
          readAddress += hexToByte(c);

#ifdef debug
          printHex16(readAddress);
#endif

          crc += readAddress >> 8;
          crc += readAddress & 0x00FF;
#ifdef debug
          Serial.print("c");   
#endif

          // reading data type
          c = getNextChar();
          type = hexToByte(c) << 4;
          c = getNextChar();
          type += hexToByte(c);
#ifdef debug
          printHex8(type);
#endif

          crc += type;

#ifdef debug
          Serial.print("d");
#endif

          if (type == 0x01) {
            endOfFile = true;
          }

          // read data bytes
          for (x = 0; x < count; x++) {
            c = getNextChar();
            value = hexToByte(c) << 4;
            c = getNextChar();
            value += hexToByte(c);

#ifdef debug
            printHex8(value);
            Serial.print("e");
#endif

            data[x] = value;
            crc += value;
          }
          // read CRC
          c = getNextChar();
          readcrc = hexToByte(c) << 4;
          c = getNextChar();
          readcrc += hexToByte(c);

#ifdef debug
          printHex8(readcrc);
          Serial.print("f");
#endif
          crc += readcrc;
          // check CRC
          value = crc & 0x00FF;
#ifdef debug
          printHex8(value);
#endif
          if (value == 0) {
          Serial.println("ok");
          p = 0;

 for (x = 0; x < count; x++) {     //separierten Code speichern
  Max = readAddress + x;            //höchsten Index ermitteln
  DD[readAddress + x] = data[x];
}
          } else {
            Serial.println(", CRC Error");
            endOfFile = true;
            p = 1;
          }
} // Ende do
while (!(endOfFile));
Serial.println("endOfFile");
//Ende do-while

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::            
  //Übertragung fertig, Programmierung beginnt          
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
if (p == 1) {goto Ende;}   //Im Fehlerfall


    //Versetzt TPS in den Programmiermodus
digitalWrite(12,LOW);               //S2 "gedrückt"
delay(50);
digitalWrite(11,LOW);               //S3 reset "gedrückt"
delay(300);
digitalWrite(11,HIGH);              //S3 "losgelassen"
delay(1000);
digitalWrite(12,HIGH);              //S2 "losgelassen"
delay(500);
Serial.println("");
Serial.println("Programmiermodus ein");


for (x = 0; x < Max; x++) {     //Code abrufen
p=0;
  Nibble1 = DD[x] & 0xF0;
  Nibble1 = Nibble1>>4;
Program(Nibble1);               //zur Tastenprogrammierung

  p=1;
  Nibble2 = DD[x] & 0x0F;
Program(Nibble2);
};  //Ende for

//S3 Reset. Ende Programmierung
digitalWrite(11,LOW);                
delay(600);
digitalWrite(11,HIGH);
Serial.println("Fertig!");

} // Ende if "w"........................................
          
}  //Ende while (serial available >0)

if(myChar == 'e'){               //Programmende: SPS_Emu sendet "e"
  endOfPrg = true;};
} //Ende while (!endOfPrg)

Ende:      Serial.println("end");
           Serial.end();
} //Ende Programm void loop ........................................................... 


//Unterprogramme ::::::::::::::

char getNextChar() {
  while (!Serial.available()) {
  }
  return  Serial.read();
}
byte hexToByte (char c) {
  if ( (c >= '0') && (c <= '9') ) {
    return c - '0';
  }
  if ( (c >= 'A') && (c <= 'F') ) {
    return (c - 'A') + 10;
  }
}

void printCheckSum(int value) {
  int checksum = value & 0xFF;
  checksum = (checksum ^ 0xFF) + 1;
  printHex8(checksum);
  Serial.println();
}
void printHex16(int num) {
  char tmp[5];
  tmp[0] = nibbleToHex(num >> 12);
  tmp[1] = nibbleToHex(num >> 8);
  tmp[2] = nibbleToHex(num >> 4);
  tmp[3] = nibbleToHex(num);
  tmp[4] = 0x00;
  Serial.print(tmp);
}
void printHex8(int num) {
  char tmp[3];
  tmp[0] = nibbleToHex(num >> 4);
  tmp[1] = nibbleToHex(num);
  tmp[2] = 0x00;
  Serial.print(tmp);
}

byte nibbleToHex (byte value) {
  byte c = value & 0x0F;
  if ( (c >= 0) && (c <= 9) ) {
    return c + '0';
  }
  if ( (c >= 10) && (c <= 15) ) {
    return (c + 'A') - 10;
  }
}

void Program(byte Nibble) {          //programmiert TPS
for(i=0; i<=Nibble; i++){
digitalWrite(13,LOW);                 //"betätigt" S1
Serial.print(i,HEX);                 //siehe Anmerkung
delay(50);
digitalWrite(13,HIGH);
delay(50);
}
delay(80);
digitalWrite(12,LOW);                //"betätigt" S2
Serial.print("  ");
delay(80);
digitalWrite(12,HIGH);
delay(200);                          //es folgt 2.Nibble

if(p == 1){                          //es folgt neue Zeile
delay(800);
Serial.println("");
}
}

//Anmerkung:
//die Serial.print-Anweisung ist für den Fall gedacht, dass der Code über den Seriellen Monitor
//gesendet wird. Bei direkter Übertragung aus SPS_Emu heraus geht das ins Leere.
